require 'devbootcamp/oauth'
require 'devbootcamp/user'

module Devbootcamp::Auth

  Error = Class.new(StandardError)

  class << self

    attr_accessor :cache

    def get(path, options={})
      raise Error, "Devbootcamp::OAuth.token is nil" if Devbootcamp::OAuth.token.nil?

      cache_for = options.delete(:cache_for)

      make_request = ->(*){
        Devbootcamp::OAuth.token.get(path).body
      }

      response = if cache && cache_for
        cache.fetch("Devbootcamp::Auth::#{path}", :expires_in => cache_for, &make_request)
      else
        make_request.call
      end

      JSON.parse(response)
    end

  end

end
