module Devbootcamp::Auth::Helpers

  def setup_devbootcamp_oauth!
    Devbootcamp::OAuth.callback_url = to(oauth_callback_path)
    Devbootcamp::OAuth.token_from_hash(session[:devbootcamp_oauth_token])
  end

  def authenticated?
    !!session[:devbootcamp_oauth_token]
  end

  def oauth_sign_in_page_url
    Devbootcamp::OAuth.authorize_url
  end

  def authenticate!
    if Devbootcamp::OAuth.authorize!(params[:code])
      session[:devbootcamp_oauth_token] = Devbootcamp::OAuth.token_as_hash
    end
    authenticated?
  end

  def deauthenticate!
    session.delete(:devbootcamp_oauth_token)
    session.delete(:current_user_attributes)
  end

  def current_user= current_user
    @current_user = current_user
    session[:current_user_attributes] = current_user.attributes
  end

  def current_user
    return nil unless authenticated?
    return @current_user if @current_user
    if session[:current_user_attributes]
      @current_user = Devbootcamp::User.new(session[:current_user_attributes])
    else
      self.current_user = Devbootcamp::User.me
    end
  end

end
