require 'devbootcamp/model'

class Devbootcamp::Cohort < Devbootcamp::Model

  def self.all
    Devbootcamp::Auth.get("/cohorts", cache_for: 1.week).map(&method(:new))
  end

  def self.names
    all.map(&:name)
  end

  def sf?
    location == "San Francisco"
  end

  def chi?
    location == "Chicago"
  end

  def users
    @users ||=Devbootcamp::Auth.get("/cohorts/#{id}/users", cache_for: 1.day).map(&Devbootcamp::User.method(:new))
  end

  attributes(
    :id,
    :name,
    :created_at,
    :updated_at,
    :in_session,
    :start_date,
    :location,
    :email,
    :visible,
    :slug
  )

end
