require 'devbootcamp/model'

class Devbootcamp::User < Devbootcamp::Model

  def self.find(user_id)
    raise ArgumentError, "user_id cannot be blank" if user_id.blank?
    new Devbootcamp::Auth.get("/users/#{user_id}")
  end

  def self.me
    new Devbootcamp::Auth.get('/me')
  end

  def self.staff
    Devbootcamp::Auth.get('/staff', cache_for: 1.hour).map(&method(:new))
  end

  attributes :id, :name, :email, :admin, :cohort_id, :avatar_image_url

  alias_method :admin?, :admin

end
